<template>
    <div class="app-container">
      <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
        <el-form-item label="品牌方id" prop="breweryId">
          <el-input
            v-model="queryParams.breweryId"
            placeholder="请输入品牌方id"
            clearable
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item label="方案名" prop="planName">
          <el-input
            v-model="queryParams.planName"
            placeholder="请输入方案名"
            clearable
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item label="可领取用户数量" prop="receivedUserCount">
          <el-input
            v-model="queryParams.receivedUserCount"
            placeholder="请输入可领取用户数量"
            clearable
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item label="每用户可领取啤酒币数量" prop="receivedCoinCount">
          <el-input
            v-model="queryParams.receivedCoinCount"
            placeholder="请输入每用户可领取啤酒币数量"
            clearable
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item label="有效天数" prop="effectiveDays">
          <el-input
            v-model="queryParams.effectiveDays"
            placeholder="请输入有效天数"
            clearable
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item label="每日领取次数" prop="receiveTimes">
          <el-input
            v-model="queryParams.receiveTimes"
            placeholder="请输入每日领取次数"
            clearable
            @keyup.enter="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
          <el-button icon="Refresh" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
  
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="Plus"
            @click="handleAdd"
            v-hasPermi="['brewery:plan:add']"
          >新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="success"
            plain
            icon="Edit"
            :disabled="single"
            @click="handleUpdate"
            v-hasPermi="['brewery:plan:edit']"
          >修改</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="Delete"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['brewery:plan:remove']"
          >删除</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="warning"
            plain
            icon="Download"
            @click="handleExport"
            v-hasPermi="['brewery:plan:export']"
          >导出</el-button>
        </el-col>
        <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
  
      <el-table v-loading="loading" :data="planList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="${comment}" align="center" prop="id" />
        <el-table-column label="品牌方id" align="center" prop="breweryId" />
        <el-table-column label="方案名" align="center" prop="planName" />
        <el-table-column label="可领取用户数量" align="center" prop="receivedUserCount" />
        <el-table-column label="每用户可领取啤酒币数量" align="center" prop="receivedCoinCount" />
        <el-table-column label="有效天数" align="center" prop="effectiveDays" />
        <el-table-column label="每日领取次数" align="center" prop="receiveTimes" />
        <el-table-column label="备注" align="center" prop="remark" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['brewery:plan:edit']">修改</el-button>
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['brewery:plan:remove']">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      
      <pagination
        v-show="total>0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
      />
  
      <!-- 添加或修改啤酒币方案对话框 -->
      <el-dialog :title="title" v-model="open" width="500px" append-to-body>
        <el-form ref="planRef" :model="form" :rules="rules" label-width="80px">
          <el-form-item label="品牌方id" prop="breweryId">
            <el-input v-model="form.breweryId" placeholder="请输入品牌方id" />
          </el-form-item>
          <el-form-item label="方案名" prop="planName">
            <el-input v-model="form.planName" placeholder="请输入方案名" />
          </el-form-item>
          <el-form-item label="可领取用户数量" prop="receivedUserCount">
            <el-input v-model="form.receivedUserCount" placeholder="请输入可领取用户数量" />
          </el-form-item>
          <el-form-item label="每用户可领取啤酒币数量" prop="receivedCoinCount">
            <el-input v-model="form.receivedCoinCount" placeholder="请输入每用户可领取啤酒币数量" />
          </el-form-item>
          <el-form-item label="有效天数" prop="effectiveDays">
            <el-input v-model="form.effectiveDays" placeholder="请输入有效天数" />
          </el-form-item>
          <el-form-item label="每日领取次数" prop="receiveTimes">
            <el-input v-model="form.receiveTimes" placeholder="请输入每日领取次数" />
          </el-form-item>
          <el-form-item label="备注" prop="remark">
            <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
          </el-form-item>
        </el-form>
        <template #footer>
          <div class="dialog-footer">
            <el-button type="primary" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
          </div>
        </template>
      </el-dialog>
    </div>
  </template>
  
  <script setup name="Plan">
  import { listPlan, getPlan, delPlan, addPlan, updatePlan } from "@/api/brewery/plan";
  
  const { proxy } = getCurrentInstance();
  
  const planList = ref([]);
  const open = ref(false);
  const loading = ref(true);
  const showSearch = ref(true);
  const ids = ref([]);
  const single = ref(true);
  const multiple = ref(true);
  const total = ref(0);
  const title = ref("");
  
  const data = reactive({
    form: {},
    queryParams: {
      pageNum: 1,
      pageSize: 10,
      breweryId: null,
      planName: null,
      receivedUserCount: null,
      receivedCoinCount: null,
      effectiveDays: null,
      receiveTimes: null,
    },
    rules: {
    }
  });
  
  const { queryParams, form, rules } = toRefs(data);
  
  /** 查询啤酒币方案列表 */
  function getList() {
    loading.value = true;
    listPlan(queryParams.value).then(response => {
      planList.value = response.rows;
      total.value = response.total;
      loading.value = false;
    });
  }
  
  // 取消按钮
  function cancel() {
    open.value = false;
    reset();
  }
  
  // 表单重置
  function reset() {
    form.value = {
      id: null,
      breweryId: null,
      planName: null,
      receivedUserCount: null,
      receivedCoinCount: null,
      effectiveDays: null,
      receiveTimes: null,
      createBy: null,
      createTime: null,
      updateBy: null,
      updateTime: null,
      remark: null
    };
    proxy.resetForm("planRef");
  }
  
  /** 搜索按钮操作 */
  function handleQuery() {
    queryParams.value.pageNum = 1;
    getList();
  }
  
  /** 重置按钮操作 */
  function resetQuery() {
    proxy.resetForm("queryRef");
    handleQuery();
  }
  
  // 多选框选中数据
  function handleSelectionChange(selection) {
    ids.value = selection.map(item => item.id);
    single.value = selection.length != 1;
    multiple.value = !selection.length;
  }
  
  /** 新增按钮操作 */
  function handleAdd() {
    reset();
    open.value = true;
    title.value = "添加啤酒币方案";
  }
  
  /** 修改按钮操作 */
  function handleUpdate(row) {
    reset();
    const _id = row.id || ids.value
    getPlan(_id).then(response => {
      form.value = response.data;
      open.value = true;
      title.value = "修改啤酒币方案";
    });
  }
  
  /** 提交按钮 */
  function submitForm() {
    proxy.$refs["planRef"].validate(valid => {
      if (valid) {
        if (form.value.id != null) {
          updatePlan(form.value).then(response => {
            proxy.$modal.msgSuccess("修改成功");
            open.value = false;
            getList();
          });
        } else {
          addPlan(form.value).then(response => {
            proxy.$modal.msgSuccess("新增成功");
            open.value = false;
            getList();
          });
        }
      }
    });
  }
  
  /** 删除按钮操作 */
  function handleDelete(row) {
    const _ids = row.id || ids.value;
    proxy.$modal.confirm('是否确认删除啤酒币方案编号为"' + _ids + '"的数据项？').then(function() {
      return delPlan(_ids);
    }).then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    }).catch(() => {});
  }
  
  /** 导出按钮操作 */
  function handleExport() {
    proxy.download('brewery/plan/export', {
      ...queryParams.value
    }, `plan_${new Date().getTime()}.xlsx`)
  }
  
  getList();
  </script>
  